#ifndef HTML_OUTPUT_H
#define HTML_OUTPUT_H

#include "findMotif.h"

// #define color_A "<font color=\"red\"><tt><b>A</b> </tt></font>"
// #define color_C "<font color=\"blue\"><tt><b>C</b> </tt></font>"
// #define color_G "<font color=\"orange\"><tt><b>G</b> </tt></font>"
// #define color_T "<font color=\"green\"><tt><b>T</b> </tt></font>"

#define color_A "<font color='#8B0000'><tt><b>A</b> </tt></font>"
#define color_C "<font color='#00008B'><tt><b>C</b> </tt></font>"
#define color_G "<font color='#FF8000'><tt><b>G</b> </tt></font>"
#define color_T "<font color='#006400'><tt><b>T</b> </tt></font>"


class BS {
 public:
  // constructor
  BS ( const int &_seqno, const char *_seq, const int &_pos,
       const bool &_forward, double &_score):
    seqno(_seqno), seq(_seq), pos(_pos), forward(_forward), score(_score)
  {}
  const int seqno;
  const char *seq;
  const int pos;
  const bool forward;
  const double score;

  // comparing function
  static bool BS_compare(BS *bs1, BS *bs2);
};


class HTML_output {
 public:
  HTML_output (FindMotif &_fm, const int out_size);
  void output(vector<double*> &seedVec, ostream &os);
  void output_Prob(const double *prob_mat, ostream &os);
  void output_BS(const double *prob_mat, const double &alpha,
		 ostream &os);
  void output_BS2( DNA *dna, const char *seq,
		   vector<BS *> &all_substr, ostream &os, bool &is_odd);
 private:
  FindMotif &fm;
  const int motif_len;
  const int num_true_seq;
  const int num_false_seq;
  const int output_size;
  vector<DNA*> & true_dna_vec;
  vector<DNA*> & false_dna_vec;
};

#endif
